/*
 * Coordiantion front back
 *
 * School project
 *
 * API version: 1.0.0
 * Contact: paul.tedesco@live.fr
 * Generated by: Swagger Codegen (https://github.com/swagger-api/swagger-codegen.git)
 */
package swagger

import (
	"fmt"
	"net/http"
	"strings"

	"github.com/gorilla/mux"
)

type Route struct {
	Name        string
	Method      string
	Pattern     string
	HandlerFunc http.HandlerFunc
}

type Routes []Route

func NewRouter() *mux.Router {
	router := mux.NewRouter().StrictSlash(true)
	for _, route := range routes {
		var handler http.Handler
		handler = route.HandlerFunc
		handler = Logger(handler, route.Name)

		router.
			Methods(route.Method).
			Path(route.Pattern).
			Name(route.Name).
			Handler(handler)
	}

	return router
}

func Index(w http.ResponseWriter, r *http.Request) {
	fmt.Fprintf(w, "Hello World!")
}

var routes = Routes{
	Route{
		"Index",
		"GET",
		"/",
		Index,
	},

	Route{
		"TokenLoginPost",
		strings.ToUpper("Post"),
		"/token/login",
		TokenLoginPost,
	},

	Route{
		"UsersGet",
		strings.ToUpper("Get"),
		"/users",
		UsersGet,
	},

	Route{
		"UsersIdDelete",
		strings.ToUpper("Delete"),
		"/users/{id}",
		UsersIdDelete,
	},

	Route{
		"UsersIdGet",
		strings.ToUpper("Get"),
		"/users/{id}",
		UsersIdGet,
	},

	Route{
		"UsersIdPut",
		strings.ToUpper("Put"),
		"/users/{id}",
		UsersIdPut,
	},

	Route{
		"UsersPost",
		strings.ToUpper("Post"),
		"/users",
		UsersPost,
	},
}
